//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window // change here if you want it in separate window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue 
#property indicator_width1  2

//
//
//
//
//

extern int    Price        = PRICE_CLOSE;   
extern double SmoothLength = 15.0;
extern double SmoothPhase  = 0;

//
//
//
//
//

double smoothed[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()   { SetIndexBuffer(0, smoothed); return(0); }
int deinit() {                              return(0); }
int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      double valueToSmooth = iMA(NULL,0,1,0,MODE_SMA,Price,i);  // just replace IMA with indicator of your choice
               smoothed[i] = iSmooth(valueToSmooth,SmoothLength,SmoothPhase,i);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrkj[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (ArrayRange(wrkj,0) != Bars) ArrayResize(wrkj,Bars);
   if (length <=1) return(price);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrkj[0][k+s]=price; for(; k<10; k++) wrkj[0][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrkj[r-1][bsmax+s];
      double del2   = price - wrkj[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrkj[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrkj[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrkj[r][volty+s] = MathAbs(del2); 
         wrkj[r][vsum+s] =	wrkj[r-1][vsum+s] + (wrkj[r][volty+s]-wrkj[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrkj[r][avolty+s] = wrkj[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrkj[r][vsum+s]-wrkj[r-1][avolty+s]);
            if (wrkj[r][avolty+s] > 0)
               double dVolty = wrkj[r][volty+s]/wrkj[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrkj[r][bsmax+s] = price; else wrkj[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrkj[r][bsmin+s] = price; else wrkj[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrkj[r][0+s] = price + alpha*(wrkj[r-1][0+s]-price);
         wrkj[r][1+s] = (price - wrkj[r][0+s])*(1-beta) + beta*wrkj[r-1][1+s];
         wrkj[r][2+s] = (wrkj[r][0+s] + R*wrkj[r][1+s]);
         wrkj[r][3+s] = (wrkj[r][2+s] - wrkj[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrkj[r-1][3+s];
         wrkj[r][4+s] = (wrkj[r-1][4+s] + wrkj[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrkj[r][4+s]);
}